import 'package:flutter/cupertino.dart';

class OpacityTransition extends StatefulWidget {

  final Widget child;
  final int durationMs;

  const OpacityTransition({Key? key, required this.child, this.durationMs = 500}) : super(key: key);

  @override
  _OpacityState createState() => _OpacityState();
}

class _OpacityState extends State<OpacityTransition> with TickerProviderStateMixin {

  late AnimationController controller;


  @override
  void initState() {
    super.initState();

    controller = AnimationController(
        duration: Duration(milliseconds: widget.durationMs),
        lowerBound: 0.5,
        upperBound: 1.0,
        vsync: this);
    controller.forward();
  }

  @override
  Widget build(BuildContext context) {
    return FadeTransition(
      opacity: controller,
      child: widget.child,
    );
  }

  @override
  void dispose() {
    controller.dispose();
    super.dispose();
  }
}